package com.example.tdl.util;

import com.example.tdl.domain.vo.AlarmRuleVo;
import com.example.tdl.domain.vo.ResultAlarmVo;
import com.example.tdl.domain.vo.ResultBoschAlarmVo;
import com.example.tdl.service.AlarmService;
import com.example.tdl.service.BoschAlarmService;
import com.example.tdl.service.redis.AlarmRedisService;
import com.google.gson.Gson;

import java.util.ArrayList;
import java.util.List;

public class AlarmRule {

    private static  Gson gson = new Gson();

    private static List<String> list = new ArrayList<String>(){{
        add("T");
        add("h");
        add("a1");
        add("ta");
    }};

    public static void saveAlarmRule(String topic, String TDLSN, String alarmType, String companyNo, BoschAlarmService alarmService, AlarmRedisService alarmRedisService){
        ResultBoschAlarmVo alarmVo =  alarmService.getByType(alarmType,companyNo);
        for(String alias :list){
            List<AlarmRuleVo> alarmRuleVos = new ArrayList<>();
            AlarmRuleVo alarmRuleVo = new AlarmRuleVo();
            alarmRuleVo.setPriority("1");
            switch(alias) {
                case "T" :
                    if(alarmVo.getTemLower() !=null  && alarmVo.getTiltUpper() !=null){
                        alarmRuleVo.setLowerval(alarmVo.getTemLower());
                        alarmRuleVo.setUpperval(alarmVo.getTemUpper());
                        alarmRuleVo.setMaxval(alarmVo.getTemMax());
                        alarmRuleVo.setMinval(alarmVo.getTemMin());
                        alarmRuleVo.setMode("full_normal");
                    }else {
                        alarmRuleVo.setMaxval(alarmVo.getTemMax());
                        alarmRuleVo.setMinval(alarmVo.getTemMin());
                        alarmRuleVo.setMode("twoway");
                    }
                    break;
                case "h":
                     if(alarmVo.getHumidityLower() !=null  && alarmVo.getHumidityUpper() !=null){
                        alarmRuleVo.setLowerval(alarmVo.getHumidityUpper());
                        alarmRuleVo.setUpperval(alarmVo.getHumidityLower());
                        alarmRuleVo.setMaxval(alarmVo.getHumidityMax());
                        alarmRuleVo.setMinval(alarmVo.getHumidityMin());
                        alarmRuleVo.setMode("full_normal");
                    }else {
                        alarmRuleVo.setMaxval(alarmVo.getHumidityMax());
                        alarmRuleVo.setMinval(alarmVo.getHumidityMin());
                        alarmRuleVo.setMode("twoway");
                    }
                    break;
                case "ta":
                     if(alarmVo.getTiltUpper() !=null ){
                        alarmRuleVo.setUpperval(alarmVo.getTiltUpper());
                        alarmRuleVo.setMaxval(alarmVo.getTilt());
                        alarmRuleVo.setMode("upper_half");
                    }else {
                        alarmRuleVo.setMaxval(alarmVo.getTilt());
                        alarmRuleVo.setMode("greater");
                    }
                    break;
                case "a1":
                    if(alarmVo.getShockUpper() !=null ){
                        alarmRuleVo.setUpperval(alarmVo.getShockUpper().doubleValue());
                        alarmRuleVo.setMaxval(alarmVo.getShock().doubleValue());
                        alarmRuleVo.setMode("upper_half");
                    }else {
                        alarmRuleVo.setMaxval(alarmVo.getShock().doubleValue());
                        alarmRuleVo.setMode("greater");
                    }
                    break;
                default:
                        break;
            }
            alarmRuleVos.add(alarmRuleVo);
            //向redis中写入报警信息
            alarmRedisService.hmSet(topic,"TDL-" +TDLSN+"_" +alias,gson.toJson(alarmRuleVos));
        }
    }
}
